% CoMa2 - SS11
% Aufg.8.2 2.
function y = exEul_harmO(x0,z0,tau,N,omega)
% expl.Euler fr den harmonischen Oszillator
% Inputs: Anfangswerte x0 und z0(=x'(0)), Schrittweite tau, Anzahl N der 
% Schritte, \omega
% Output: Gitterfunktion x, reprsentiert durch eine Matrix;
% die k-Spalte entspricht (x_k,x'_k) ~ (x(k\tau),x'(k\tau))

% setze z' := x
% das sind unsere Gleichungen erster Ordnung:
% 1) x' = z
% 2) z' = -\omega^2 x
% --> expl.Euler-Verfahren fr das entsprechende AWP
% 1) x_0 = 1, x_{k+1} = x_k + \tau*z_k
% 2) z_0 = -1, z_{k+1} = z_k + \tau*(-\omega^2 x_k)

% ...alles klar; sei y(t) = (x(t),x'(t))
y = zeros(2,N+1);
y(:,1) = [x0;z0];
for k=1:N
    y(1,k+1) = y(1,k) + tau*y(2,k);
    y(2,k+1) = y(2,k) - tau*omega^2*y(1,k);
end