% CoMa2 - SS11
% Aufg.8.2 3.
% Test der Euler-Verfahren fr den harmonischen Oszillator

clear all

t = 0:0.01:30;  % Zeitintervall

% fr \omega = 1
% zuerst plotten wir das Phasenportrait("y-Komponente ber x-Komponente")
% der analytischen Lsung
% x(t) = cos(\omega t) - sin(\omega t)
% x'(t) = -\omega sin(\omega t) - \omega cos(\omega t)
figure(1);
subplot(2,2,1);
plot(cos(t)-sin(t),-sin(t)-cos(t));
title('analytische Lsung; \omega = 1');

% dann die diskreten Phasenflsse zu beiden Verfahren
% expl.Euler
tau = [0.1 0.01 0.001];     % Schrittweiten
for i=1:3
    N = 30/tau(i);
    x = exEul_harmO(1,-1,tau(i),N,1);
    subplot(2,2,i+1);
    plot(x(1,:),x(2,:));
    title(['diskrete Lsung(expl.Euler); \omega=1, \tau = ' num2str(tau(i))]);
end

% impl.Euler:
figure(2);
subplot(2,2,1);
plot(cos(t)-sin(t),-sin(t)-cos(t));
title('analytische Lsung; \omega = 1');
tau = [0.1 0.01 0.001];     % Schrittweiten
for i=1:3
    N = 30/tau(i);
    x = imEul_harmO(1,-1,tau(i),N,1);
    subplot(2,2,i+1);
    plot(x(1,:),x(2,:));
    title(['diskrete Lsung(impl.Euler); \omega=1, \tau = ' num2str(tau(i))]);
end

% und das ganze nochmal fr \omega = 5...
% zuerst plotten wir das Phasenportrait("y-Komponente ber x-Komponente")
% der analytischen Lsung
% x(t) = cos(\omega t) - (1/5) sin(\omega t)
% x'(t) = -\omega sin(\omega t) - cos(\omega t)
figure(3);
subplot(2,2,1);
plot(cos(5*t)-(1/5)*sin(5*t),-5*sin(5*t)-cos(5*t));
title('analytische Lsung; \omega = 5');

% dann die diskreten Phasenflsse zu beiden Verfahren
% expl.Euler
tau = [0.1 0.01 0.001];     % Schrittweiten
for i=1:3
    N = 30/tau(i);
    x = exEul_harmO(1,-1,tau(i),N,5);
    subplot(2,2,i+1);
    plot(x(1,:),x(2,:));
    title(['diskrete Lsung(expl.Euler); \omega=5, \tau = ' num2str(tau(i))]);
end

% impl.Euler:
figure(4);
subplot(2,2,1);
plot(cos(5*t)-(1/5)*sin(5*t),-5*sin(5*t)-cos(5*t));
title('analytische Lsung; \omega = 5');
tau = [0.1 0.01 0.001];     % Schrittweiten
for i=1:3
    N = 30/tau(i);
    x = imEul_harmO(1,-1,tau(i),N,5);
    subplot(2,2,i+1);
    plot(x(1,:),x(2,:));
    title(['diskrete Lsung(impl.Euler); \omega=5, \tau = ' num2str(tau(i))]);
end